Subject: Re: GCC 12 warnings

From: Kees Cook <[email-masked]>
Date: Fri, 20 May 2022 09:46:36 -0700

On Thu, May 19, 2022 at 07:36:18PM -0700, Jakub Kicinski wrote:
> I'm sure you're involved in a number of glorious GCC 12 conversations..

Yeah, and I think I've even found a gcc bug. :|

> We have a handful of drivers in networking which get hit by
> -Warray-bounds because they allocate partial structures (I presume 
> to save memory, misguided but more than 15min of work to refactor).

Yeah, this idiom is pretty common I've noticed -- I fixed a few of these
in the initial work for -Warray-bounds on GCC 11 and earlier, but wow
did GCC 12 do something extra internally.

> Since -Warray-bounds is included by default now this is making our
> lives a little hard [1]. Is there a wider effort to address this?
> If not do you have a recommendation on how to deal with it?

Looks like the issue was this?
https://lore.kernel.org/all/[email-masked]/

Ah, from cf2df74e202d ("net: fix dev_fill_forward_path with pppoe + bridge")

You mean you missed this particular warning because of the other GCC
12 warnings?

> My best idea is to try to isolate the bad files and punt -Warray-bounds
> to W=1 for those, so we can prevent more of them getting in but not
> break WERROR builds on GCC 12. That said, I'm not sure how to achieve
> that.. This for example did not work:
> 
> --- a/drivers/net/ethernet/mediatek/Makefile
> +++ b/drivers/net/ethernet/mediatek/Makefile
> @@ -9,5 +9,9 @@ mtk_eth-$(CONFIG_NET_MEDIATEK_SOC_WED) += mtk_wed.o
>  ifdef CONFIG_DEBUG_FS
>  mtk_eth-$(CONFIG_NET_MEDIATEK_SOC_WED) += mtk_wed_debugfs.o
>  endif
>  obj-$(CONFIG_NET_MEDIATEK_SOC_WED) += mtk_wed_ops.o
>  obj-$(CONFIG_NET_MEDIATEK_STAR_EMAC) += mtk_star_emac.o
> +
> +ifneq ($(findstring 1, $(KBUILD_EXTRA_WARN)),)
> +CFLAGS_mtk_ppe.o += -Wno-array-bounds
> +endif

This worked for me:

diff --git a/drivers/net/can/usb/kvaser_usb/Makefile b/drivers/net/can/usb/kvaser_usb/Makefile
index cf260044f0b9..43eb921f9102 100644
--- a/drivers/net/can/usb/kvaser_usb/Makefile
+++ b/drivers/net/can/usb/kvaser_usb/Makefile
@@ -1,3 +1,7 @@
 # SPDX-License-Identifier: GPL-2.0-only
 obj-$(CONFIG_CAN_KVASER_USB) += kvaser_usb.o
 kvaser_usb-y = kvaser_usb_core.o kvaser_usb_leaf.o kvaser_usb_hydra.o
+
+ifeq ($(KBUILD_EXTRA_WARN),)
+CFLAGS_kvaser_usb_hydra.o += -Wno-array-bounds
+endif

-- 
Kees Cook